import pandas as pd
import requests
import matplotlib.pyplot as plt
import json
from pandas.io.json import json_normalize


baseurl = "https://empress.clai.io:1342/index.php?"
token = "&format=JSON&token_auth=92ff8605e20332d73e812cb23865a3bd"
module = "module=API&"
idSite = "1"  # don't change - there's only one page

#visitorId = "0852851164c0a96b" # trx_usertest_1, the shortest one
#visitorId = "4bb448a8dfff8f74"  # tfs_jorgen_07
#visitorId = "e845c1e717835152"  # kerstin
#visitorId = "5546b9ebe26a7051" # tfs_berit_05
visitorId = "62094dd800f813de"  # yu


method = "Live.getVisitorProfile"
#method = "UserId.getUsers"

endpoint = baseurl + module + "method="+method+"&idSite="+idSite+"&visitorId="+visitorId+"&period=range&date=2018-04-23,2018-05-13"+token
token = 'dXNlcjpaRHNFaDlaVGdiSzJ4cWE4Z1pFQnZnN1BQNGR1a0U='
headers = {"Authorization":"Basic " + token}
print(endpoint)

#data = pd.DataFrame(requests.get(endpoint,headers=headers).json())
data_raw = requests.get(endpoint,headers=headers).json()
#data_raw

# get visit logs for all sessions and put them into a 2D array
lastVisits = data_raw['lastVisits']  # details of all sessions
#print(lastVisits)
totalVisits = data_raw['totalVisits']  # the number of sessions
#print(totalVisits)
visitDetailNorm = [0] * totalVisits
actionsNum = [0] * totalVisits
userflow = []
for i in range(totalVisits):
    visitDetailNorm[i] = json_normalize(lastVisits[i])  # normalize each session
    actionsNum[i] = visitDetailNorm[i]['actions']  # the number of urls visited in each session
    url = []
    for j in range(int(actionsNum[i])):
        url.append(visitDetailNorm[i]['actionDetails'][0][j]['url'])  # put urls in all sessions in one array
    userflow.append(url)  # form a 2D array on the base on the 1D arrays
for a in range(totalVisits):
    print(userflow[a])
